"""
Django settings for task_queues project.

Generated by 'django-admin startproject' using Django 3.0.3.

For more information on this file, see
https://docs.djangoproject.com/en/3.0/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/3.0/ref/settings/
"""

import os
import configparser

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/3.0/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'r3c%sr8x$8fvb-$fmf5-%$-q+-ozgd#0v#)#h7k5lwp%uoyj^t'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = False

ALLOWED_HOSTS = []


# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'background_task',
    'djcelery',
    'celery'
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'task_queues.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'task_queues.wsgi.application'


# Database
# https://docs.djangoproject.com/en/3.0/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.sqlite3',
        'NAME': os.path.join(BASE_DIR, 'db.sqlite3'),
    }
}


# Password validation
# https://docs.djangoproject.com/en/3.0/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]

MAX_ATTEMPTS = 2
BACKGROUND_TASK_RUN_ASYNC = False
BACKGROUND_TASK_ASYNC_THREADS = 2
# Internationalization
# https://docs.djangoproject.com/en/3.0/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_L10N = True

USE_TZ = True


config = configparser.ConfigParser()
path = os.getcwd()
# finding path to config.ini located in hackathon-product directory
project_root_idx = path.find("task_queues/task_queues")
# print(project_root_idx,"*********")
conf_path = path[:project_root_idx]
# print("****** conf_path", conf_path)
# config.read(conf_path+'config.ini')
config.read("/root/task_queues/hackathon-product/task_queues/"+'config.ini')

# General
MOUNT_DIR_PATH = str(config['general']['MOUNT_DIR_PATH'])
datadrive_host = str(config['general']['datadrive_host'])
datadrive_port = int(config['general']['datadrive_port'])
GCP_BUCKETS_URL = str(config['general']['GCP_BUCKETS_URL'])
PARTS_BUCKET = str(config['general']['PARTS_BUCKET'])
EXPERIMENTS_BUCKET = str(config['general']['EXPERIMENTS_BUCKET'])
DOCKER_VERSION = str(config['general']['DOCKER_VERSION'])
BASE_URL = str(config['general']['BASE_URL'])

if not os.path.exists(MOUNT_DIR_PATH):
            os.mkdir(MOUNT_DIR_PATH)
            # os.chmod(MOUNT_DIR_PATH, stat.S_IRWXO | stat.S_IRWXU | stat.S_IRWXG)
import os, stat
MODELS_PATH = os.path.join(MOUNT_DIR_PATH,"models")
if not os.path.exists(MODELS_PATH):
            os.mkdir(MODELS_PATH)
            # os.chmod(MODELS_PATH, stat.S_IRWXO | stat.S_IRWXU | stat.S_IRWXG)
EXPERIMENT_PATH = os.path.join(MODELS_PATH,"experiments")
if not os.path.exists(EXPERIMENT_PATH):
            os.mkdir(EXPERIMENT_PATH)
            # os.chmod(EXPERIMENT_PATH, stat.S_IRWXO | stat.S_IRWXU | stat.S_IRWXG)

# Mongo database
MONGO_COLLECTION_PARTS = str(config['database']['MONGO_COLLECTION_PARTS'])
MONGO_COLLECTIONS = {"MONGO_COLLECTION_PARTS": MONGO_COLLECTION_PARTS}
MONGO_HOST= str(config['database']['MONGO_HOST'])
MONGO_PORT= int(config['database']['MONGO_PORT'])
MONGO_DB = str(config['database']['MONGO_DB'])


# Kafka URL
KAFKA_URL =  str(config['kafka']['KAFKA_URL'])

# Redis
REDIS_HOST = str(config['redis']['REDIS_HOST'])
REDIS_PORT = int(config['redis']['REDIS_PORT'])

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/3.0/howto/static-files/

STATIC_URL = '/static/'
